## rdma-core 33.2

=== CMakeLists.txt ===
# COPYRIGHT (c) 2016 Obsidian Research Corporation. See COPYING file
# Run cmake as:
#  mkdir build
#  cmake -GNinja ..
#  ninja
#
# Common options passed to cmake are:
#  -DIN_PLACE=1
#      Configure the build to be run from the build directory, this results in something
#      that is not installable.
#  -DCMAKE_EXPORT_COMPILE_COMMANDS=1
#      Write a compile_commands.json file for clang tooling
#  -DCMAKE_BUILD_TYPE=RelWithDebInfo
#      Change the optimization level, Debug disables optimization,
#      Release is for packagers
#  -DENABLE_VALGRIND=0 (default enabled)
#      Disable valgrind notations, this has a tiny positive performance impact
#  -DENABLE_RESOLVE_NEIGH=0 (default enabled)
#      Do not link to libnl and do not resolve neighbours internally for Ethernet,
#      and do not build iwpmd.
#  -DENABLE_STATIC=1 (default disabled)
#      Produce static libraries along with the usual shared libraries.
#  -DVERBS_PROVIDER_DIR='' (default /usr/lib.../libibverbs)
#      Use the historical search path for providers, in the standard system library.
#  -DNO_COMPAT_SYMS=1 (default disabled)
#      Do not generate backwards compatibility symbols in the shared
#      libraries. This may is necessary if using a dynmic linker that does
#      not support symbol versions, such as uclibc.
#  -DIOCTL_MODE=write (default both)
#      Disable new kABI ioctl() support and support only the legacy write
#      path. May also be 'ioctl' to disable fallback to write.
#  -DIBACM_SERVER_MODE_DEFAULT (default unix)
#      Selects how clients can connect to this server:
#      open) Allow incoming connections from any TCP client (internal or external).
#      loop) Limit incoming connections for server_port to 127.0.0.1.
#      unix) Use unix-domain sockets, hence limits service to the same machine.
#  -DIBACM_ACME_PLUS_KERNEL_ONLY_DEFAULT (default 0)
#      If non-zero, limit incoming requests to kernel or the ib_acme utility
#      (i.e. do not serve librdmacm requests)
#  -DPYTHON_EXECUTABLE
#      Override automatic detection of python to use a certain
#      exectuable. This can be used to force the build to use python2 on a
#      system that has python3 installed. Otherwise the build automatically
#      prefers python3 if available.
#   -DNO_PYVERBS=1 (default, build pyverbs)
#      Invoke cython to build pyverbs. Usually you will run with this option
#      set
#   -DENABLE_IBDIAGS_COMPAT=True (default False)
#      Include obsolete scripts. These scripts are replaced by C programs with
#      a different interface now.
#   -DNO_MAN_PAGES=1 (default 0, build/install the man pages)
#      Disable man pages. Allows rdma-core to be built and installed
#      (without man pages) when neither pandoc/rst2man nor the pandoc-prebuilt
#      directory are available.

cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
project(rdma-core C)

# CMake likes to use -rdynamic too much, they fixed it in 3.4.
if(POLICY CMP0065)
  cmake_policy(SET CMP0065 NEW)
else()
  # .. but we really do want to opt out.
  string(REPLACE "-rdynamic" "" CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "${CMAKE_SHARED_LIBRARY_LINK_C_FLAGS}")
endif()

# Make RDMA_CHECK_C_LINKER_FLAG work better
if(POLICY CMP0056)
  cmake_policy(SET CMP0056 NEW)
endif()

set(PACKAGE_NAME "RDMA")

# See Documentation/versioning.md
set(PACKAGE_VERSION "33.2")
# When this is changed the values in these files need changing too:
#   debian/control
#   debian/libibverbs1.symbols
set(IBVERBS_PABI_VERSION "33")
set(IBVERBS_PROVIDER_SUFFIX "-rdmav${IBVERBS_PABI_VERSION}.so")

#-------------------------
# Basic standard paths

# Override the CMAKE_INSTALL_ dirs to be under the build/ directory
if (IN_PLACE)
  set(CMAKE_INSTALL_SYSCONFDIR "${CMAKE_BINARY_DIR}/etc")
  set(CMAKE_INSTALL_BINDIR "${CMAKE_BINARY_DIR}/bin")
  set(CMAKE_INSTALL_SBINDIR "${CMAKE_BINARY_DIR}/bin")
  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}")
  set(CMAKE_INSTALL_LIBDIR "lib")
  set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

include(GNUInstallDirs)
# C include root
set(BUILD_INCLUDE ${CMAKE_BINARY_DIR}/include)
# Executables
set(BUILD_BIN ${CMAKE_BINARY_DIR}/bin)
# Libraries
set(BUILD_LIB ${CMAKE_BINARY_DIR}/lib)
# Static library pre-processing
set(BUILD_STATIC_LIB ${CMAKE_BINARY_DIR}/lib/statics)
# Used for IN_PLACE configuration
set(BUILD_ETC ${CMAKE_BINARY_DIR}/etc)
set(BUILD_PYTHON ${CMAKE_BINARY_DIR}/python)

set(IBDIAG_CONFIG_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/infiniband-diags")
set(IBDIAG_NODENAME_MAP_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/rdma/ib-node-name-map")

set(CMAKE_INSTALL_INITDDIR "${CMAKE_INSTALL_SYSCONFDIR}/init.d"
  CACHE PATH "Location for init.d files")
set(CMAKE_INSTALL_SYSTEMD_SERVICEDIR "${CMAKE_INSTALL_PREFIX}/lib/systemd/system"
  CACHE PATH "Location for systemd service files")
set(CMAKE_INSTALL_SYSTEMD_BINDIR "/lib/systemd"
  CACHE PATH "Location for systemd extra binaries")

set(ACM_PROVIDER_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/ibacm"
  CACHE PATH "Location for ibacm provider plugin shared library files.")
# Location to find the provider plugin shared library files
set(VERBS_PROVIDER_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/libibverbs"
  CACHE PATH "Location for provider plugin shared library files. If set to empty the system search path is used.")

# Allow the 'run' dir to be configurable, this historically has been /var/run, but
# some systems now use /run/
set(CMAKE_INSTALL_RUNDIR "var/run"
  CACHE PATH "Location for runtime information, typically /var/run, or /run")
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_RUNDIR})
  set(CMAKE_INSTALL_FULL_RUNDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_RUNDIR}")
else()
  set(CMAKE_INSTALL_FULL_RUNDIR "${CMAKE_INSTALL_RUNDIR}")
endif()

# Allow the udev rules.d dir to be configurable, this has historically been
# /lib/udev/rules.d/, but some systems now prefix /usr/
set(CMAKE_INSTALL_UDEV_RULESDIR "lib/udev/rules.d"
  CACHE PATH "Location for system udev rules, typically /lib/udev/rules.d or /usr/lib/udev/rules.d")
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_UDEV_RULESDIR})
  set(CMAKE_INSTALL_FULL_UDEV_RULESDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_UDEV_RULESDIR}")
else()
  set(CMAKE_INSTALL_FULL_UDEV_RULESDIR "${CMAKE_INSTALL_UDEV_RULESDIR}")
endif()

# Allow the perl library dir to be configurable
set(CMAKE_INSTALL_PERLDIR "share/perl5"
  CACHE PATH "Location for system perl library, typically /usr/share/perl5")
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_PERLDIR})
  set(CMAKE_INSTALL_FULL_PERLDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_PERLDIR}")
else()
  set(CMAKE_INSTALL_FULL_PERLDIR "${CMAKE_INSTALL_PERLDIR}")
endif()

# Location to place provider .driver files
if (IN_PLACE)
  set(CONFIG_DIR "${BUILD_ETC}/libibverbs.d")
  set(VERBS_PROVIDER_DIR "${BUILD_LIB}")
  set(ACM_PROVIDER_DIR "${BUILD_LIB}/ibacm")
else()
  set(CONFIG_DIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}/libibverbs.d")
endif()

set(DISTRO_FLAVOUR "None" CACHE
  STRING "Flavour of distribution to install for. This primarily impacts the init.d scripts installed.")

#-------------------------
# Load CMake components
set(BUILDLIB "${CMAKE_SOURCE_DIR}/buildlib")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${BUILDLIB}")

include(CMakeParseArguments)
include(CheckCCompilerFlag)
include(CheckIncludeFile)
include(CheckTypeSize)
include(RDMA_EnableCStd)
include(RDMA_Sparse)
include(RDMA_BuildType)
include(RDMA_DoFixup)
include(publish_headers)
include(rdma_functions)
include(pyverbs_functions)
if (NO_MAN_PAGES)
  # define empty stub functions to omit man page processing
  function(rdma_man_pages)
  endfunction()
  function(rdma_alias_man_pages)
  endfunction()
else()
  include(rdma_man)
endif()

if (NOT DEFINED ENABLE_STATIC)
  set(ENABLE_STATIC "OFF" CACHE BOOL "Produce static linking libraries as well as shared libraries.")
endif()

#-------------------------
# Setup the basic C compiler
RDMA_BuildType()
include_directories(${BUILD_INCLUDE})

# Look for Python. We prefer some variant of python 3 if the system has it.
FIND_PACKAGE(PythonInterp 3 QUIET)
if (PythonInterp_FOUND)
  # pyverbs can only use python3:
  if (NO_PYVERBS)
    set(CYTHON_EXECUTABLE "")
  else()
    FIND_PACKAGE(cython)
  endif()
else()
  # But we still must have python (be it 2) for the build process:
  FIND_PACKAGE(PythonInterp REQUIRED)
  set(CYTHON_EXECUTABLE "")
endif()

RDMA_CheckSparse()

# Require GNU99 mode
RDMA_EnableCStd()

# Extra warnings. Turn on -Wextra to keep aware of interesting developments from gcc,
# but turn off some that are not terribly useful for this source.
# FIXME: I wonder how many of the signed compares are bugs?
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WARNINGS
  "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WMISSING_PROTOTYPES "-Wmissing-prototypes")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WMISSING_DECLARATIONS "-Wmissing-declarations")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WWRITE_STRINGS "-Wwrite-strings")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WFORMAT_2 "-Wformat=2")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WCAST_FUNCTION "-Wcast-function-type")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WFORMAT_NONLITERAL "-Wformat-nonliteral")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WDATE_TIME "-Wdate-time")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WNESTED_EXTERNS "-Wnested-externs")

# At some point after 4.4 gcc fixed shadow to ignore function vs variable
# conflicts
RDMA_Check_C_Compiles(HAVE_C_WORKING_SHADOW "
 #include <unistd.h>
 int main(int argc,const char *argv[]) { int access = 1; return access; }"
  "-Wshadow")
if (HAVE_C_WORKING_SHADOW)
  RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WORKING_SHADOW "-Wshadow")
endif()

# At some point around 5.4 gcc fixed missing-field-initializers to ignore this
# common idiom we use extensively. Since this is a useful warning for
# developers try and leave it on if the compiler supports it.
RDMA_Check_C_Compiles(HAVE_C_WORKING_MISSING_FIELD_INITIALIZERS "
 struct foo { int a; int b; };
 int main(int argc,const char *argv[]) { struct foo tmp = {}; return tmp.a; }"
)
if (NOT HAVE_C_WORKING_MISSING_FIELD_INITIALIZERS)
  RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WNO_MISSING_FIELD_INITIALIZERS "-Wno-missing-field-initializers")
endif()

# Check that the compiler supports -fno-strict-aliasing.
# The use of this flag in the source is discouraged
set(NO_STRICT_ALIASING_FLAGS "")
RDMA_AddOptCFlag(NO_STRICT_ALIASING_FLAGS HAVE_NO_STRICT_ALIASING
  "-fno-strict-aliasing")

# pyverbs has a problem with var-tracking warnings, turn it off if we can.
set(NO_VAR_TRACKING_FLAGS "")
RDMA_AddOptCFlag(NO_VAR_TRACKING_FLAGS HAVE_NO_VAR_TRACKING_ASSIGNMENTS
  "-fno-var-tracking-assignments")

RDMA_Check_C_Compiles(HAVE_FUNC_ATTRIBUTE_IFUNC "
 #include <unistd.h>

 void entry(void);

 static void do_entry(void) {}
 void entry(void) __attribute__((ifunc(\"resolve_entry\")));
 typedef void (*fn_t)(void);
 static fn_t resolve_entry(void) {return &do_entry;}

 int main(int argc,const char *argv[]) { entry(); }"
)

RDMA_Check_C_Compiles(HAVE_FUNC_ATTRIBUTE_SYMVER "
 #include <unistd.h>

 void _sym(void);
 __attribute__((__symver__(\"sym@TEST_1.1\"))) void _sym(void) {}

 int main(int argc,const char *argv[]) { _sym(); }"
)

# The code does not do the racy fcntl if the various CLOEXEC's are not
# supported so it really doesn't work right if this isn't available. Thus hard
# require it.
CHECK_C_SOURCE_COMPILES("
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <sys/socket.h>
 #include <fcntl.h>
 int main(int argc,const char *argv[]) {
    open(\".\",O_RDONLY | O_CLOEXEC);
    socket(AF_INET, SOCK_STREAM | SOCK_CLOEXEC, 0);
    return 0;
 }" HAS_CLOEXEC)

if (NOT HAS_CLOEXEC)
# At least uclibc wrongly hides this POSIX constant behind _GNU_SOURCE
CHECK_C_SOURCE_COMPILES("
 #define _GNU_SOURCE
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <sys/socket.h>
 #include <fcntl.h>
 int main(int argc,const char *argv[]) {
    open(\".\",O_RDONLY | O_CLOEXEC);
    socket(AF_INET, SOCK_STREAM | SOCK_CLOEXEC, 0);
    return 0;

=== pyverbs/CMakeLists.txt ===
# SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
# Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file

rdma_cython_module(pyverbs ""
  addr.pyx
  base.pyx
  cm_enums.pyx
  cmid.pyx
  cq.pyx
  device.pyx
  enums.pyx
  mem_alloc.pyx
  mr.pyx
  pd.pyx
  qp.pyx
  wr.pyx
  xrcd.pyx
  srq.pyx
  )

rdma_python_module(pyverbs
  __init__.py
  pyverbs_error.py
  utils.py
  )

# mlx5 and efa providers are not built without coherent DMA, e.g. ARM32 build.
if (HAVE_COHERENT_DMA)
add_subdirectory(providers/mlx5)
add_subdirectory(providers/efa)
endif()

=== tests/CMakeLists.txt ===
# SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
# Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file

rdma_python_test(tests
  __init__.py
  args_parser.py
  base.py
  base_rdmacm.py
  efa_base.py
  mlx5_base.py
  rdmacm_utils.py
  test_addr.py
  test_cq.py
  test_cq_events.py
  test_cqex.py
  test_device.py
  test_efa_srd.py
  test_efadv.py
  test_mlx5_cq.py
  test_mlx5_dc.py
  test_mlx5_lag_affinity.py
  test_mlx5_pp.py
  test_mlx5_sched.py
  test_mlx5_uar.py
  test_mlx5_udp_sport.py
  test_mlx5_var.py
  test_mr.py
  test_odp.py
  test_pd.py
  test_parent_domain.py
  test_qp.py
  test_qpex.py
  test_rdmacm.py
  test_relaxed_ordering.py
  test_shared_pd.py
  utils.py
  )

rdma_python_test(tests
  run_tests.py
  )

rdma_internal_binary(
  run_tests.py
  )

=== libibverbs/man/CMakeLists.txt ===
rdma_man_pages(
  ibv_advise_mr.3.md
  ibv_alloc_dm.3
  ibv_alloc_mw.3
  ibv_alloc_null_mr.3.md
  ibv_alloc_parent_domain.3
  ibv_alloc_pd.3
  ibv_alloc_td.3
  ibv_asyncwatch.1
  ibv_attach_counters_point_flow.3.md
  ibv_attach_mcast.3.md
  ibv_bind_mw.3
  ibv_create_ah.3
  ibv_create_ah_from_wc.3
  ibv_create_comp_channel.3
  ibv_create_counters.3.md
  ibv_create_cq.3
  ibv_create_cq_ex.3
  ibv_modify_cq.3
  ibv_create_flow.3
  ibv_create_flow_action.3.md
  ibv_create_qp.3
  ibv_create_qp_ex.3
  ibv_create_rwq_ind_table.3
  ibv_create_srq.3
  ibv_create_srq_ex.3
  ibv_create_wq.3
  ibv_devices.1
  ibv_devinfo.1
  ibv_event_type_str.3.md
  ibv_fork_init.3.md
  ibv_get_async_event.3
  ibv_get_cq_event.3
  ibv_get_device_guid.3.md
  ibv_get_device_index.3.md
  ibv_get_device_list.3.md
  ibv_get_device_name.3.md
  ibv_get_pkey_index.3.md
  ibv_get_srq_num.3.md
  ibv_import_device.3.md
  ibv_import_mr.3.md
  ibv_import_pd.3.md
  ibv_inc_rkey.3.md
  ibv_modify_qp.3
  ibv_modify_qp_rate_limit.3
  ibv_modify_srq.3
  ibv_modify_wq.3
  ibv_open_device.3
  ibv_open_qp.3
  ibv_open_xrcd.3
  ibv_poll_cq.3
  ibv_post_recv.3
  ibv_post_send.3
  ibv_post_srq_ops.3
  ibv_post_srq_recv.3
  ibv_query_device.3
  ibv_query_device_ex.3
  ibv_query_ece.3.md
  ibv_query_gid.3.md
  ibv_query_gid_ex.3.md
  ibv_query_gid_table.3.md
  ibv_query_pkey.3.md
  ibv_query_port.3
  ibv_query_qp.3
  ibv_query_rt_values_ex.3
  ibv_query_srq.3
  ibv_rate_to_mbps.3.md
  ibv_rate_to_mult.3.md
  ibv_rc_pingpong.1
  ibv_read_counters.3.md
  ibv_reg_mr.3
  ibv_req_notify_cq.3.md
  ibv_rereg_mr.3.md
  ibv_resize_cq.3.md
  ibv_set_ece.3.md
  ibv_srq_pingpong.1
  ibv_uc_pingpong.1
  ibv_ud_pingpong.1
  ibv_wr_post.3.md
  ibv_xsrq_pingpong.1
  )
rdma_alias_man_pages(
  ibv_alloc_dm.3 ibv_free_dm.3
  ibv_alloc_dm.3 ibv_reg_dm_mr.3
  ibv_alloc_dm.3 ibv_memcpy_to_dm.3
  ibv_alloc_dm.3 ibv_memcpy_from_dm.3
  ibv_alloc_mw.3 ibv_dealloc_mw.3
  ibv_alloc_pd.3 ibv_dealloc_pd.3
  ibv_alloc_td.3 ibv_dealloc_td.3
  ibv_attach_mcast.3 ibv_detach_mcast.3
  ibv_create_ah.3 ibv_destroy_ah.3
  ibv_create_ah_from_wc.3 ibv_init_ah_from_wc.3
  ibv_create_comp_channel.3 ibv_destroy_comp_channel.3
  ibv_create_counters.3 ibv_destroy_counters.3
  ibv_create_cq.3 ibv_destroy_cq.3
  ibv_create_flow.3 ibv_destroy_flow.3
  ibv_create_flow_action.3 ibv_destroy_flow_action.3
  ibv_create_flow_action.3 ibv_modify_flow_action.3
  ibv_create_qp.3 ibv_destroy_qp.3
  ibv_create_rwq_ind_table.3 ibv_destroy_rwq_ind_table.3
  ibv_create_srq.3 ibv_destroy_srq.3
  ibv_create_wq.3 ibv_destroy_wq.3
  ibv_event_type_str.3 ibv_node_type_str.3
  ibv_event_type_str.3 ibv_port_state_str.3
  ibv_get_async_event.3 ibv_ack_async_event.3
  ibv_get_cq_event.3 ibv_ack_cq_events.3
  ibv_get_device_list.3 ibv_free_device_list.3
  ibv_import_pd.3 ibv_unimport_pd.3
  ibv_import_mr.3 ibv_unimport_mr.3
  ibv_open_device.3 ibv_close_device.3
  ibv_open_xrcd.3 ibv_close_xrcd.3
  ibv_rate_to_mbps.3 mbps_to_ibv_rate.3
  ibv_rate_to_mult.3 mult_to_ibv_rate.3
  ibv_reg_mr.3 ibv_dereg_mr.3
  ibv_wr_post.3 ibv_wr_abort.3
  ibv_wr_post.3 ibv_wr_complete.3
  ibv_wr_post.3 ibv_wr_start.3
  ibv_wr_post.3 ibv_wr_atomic_cmp_swp.3
  ibv_wr_post.3 ibv_wr_atomic_fetch_add.3
  ibv_wr_post.3 ibv_wr_bind_mw.3
  ibv_wr_post.3 ibv_wr_local_inv.3
  ibv_wr_post.3 ibv_wr_rdma_read.3
  ibv_wr_post.3 ibv_wr_rdma_write.3
  ibv_wr_post.3 ibv_wr_rdma_write_imm.3
  ibv_wr_post.3 ibv_wr_send.3
  ibv_wr_post.3 ibv_wr_send_imm.3
  ibv_wr_post.3 ibv_wr_send_inv.3
  ibv_wr_post.3 ibv_wr_send_tso.3
  ibv_wr_post.3 ibv_wr_set_inline_data.3
  ibv_wr_post.3 ibv_wr_set_inline_data_list.3
  ibv_wr_post.3 ibv_wr_set_sge.3
  ibv_wr_post.3 ibv_wr_set_sge_list.3
  ibv_wr_post.3 ibv_wr_set_ud_addr.3
  ibv_wr_post.3 ibv_wr_set_xrc_srqn.3
  )

=== providers/mlx5/CMakeLists.txt ===
set(MLX5_DEBUG "FALSE" CACHE BOOL
  "Enable expensive runtime logging options for the mlx5 verbs provider")
if (MLX5_DEBUG)
  add_definitions("-DMLX5_DEBUG")
endif()

set(MLX5_MW_DEBUG "FALSE" CACHE BOOL
  "Enable extra validation of memory windows for the mlx5 verbs provider")
if (MLX5_MW_DEBUG)
  add_definitions("-DMW_DEBUG")
endif()

rdma_shared_provider(mlx5 libmlx5.map
  1 1.17.${PACKAGE_VERSION}
  buf.c
  cq.c
  dbrec.c
  dr_action.c
  dr_buddy.c
  dr_crc32.c
  dr_dbg.c
  dr_devx.c
  dr_icm_pool.c
  dr_matcher.c
  dr_domain.c
  dr_rule.c
  dr_ste.c
  dr_ste_v0.c
  dr_ste_v1.c
  dr_table.c
  dr_send.c
  mlx5.c
  qp.c
  srq.c
  verbs.c
)

publish_headers(infiniband
  ../../kernel-headers/rdma/mlx5_user_ioctl_verbs.h
  mlx5_api.h
  mlx5dv.h
)

rdma_pkg_config("mlx5" "libibverbs" "${CMAKE_THREAD_LIBS_INIT}")

=== providers/mlx5/man/CMakeLists.txt ===
rdma_man_pages(
  mlx5dv_alloc_dm.3.md
  mlx5dv_alloc_var.3.md
  mlx5dv_create_cq.3.md
  mlx5dv_create_flow.3.md
  mlx5dv_create_flow_action_modify_header.3.md
  mlx5dv_create_flow_action_packet_reformat.3.md
  mlx5dv_create_flow_matcher.3.md
  mlx5dv_create_mkey.3.md
  mlx5dv_create_qp.3.md
  mlx5dv_devx_alloc_uar.3.md
  mlx5dv_devx_create_cmd_comp.3.md
  mlx5dv_devx_create_event_channel.3.md
  mlx5dv_devx_get_event.3.md
  mlx5dv_devx_obj_create.3.md
  mlx5dv_devx_qp_modify.3.md
  mlx5dv_devx_query_eqn.3.md
  mlx5dv_devx_subscribe_devx_event.3.md
  mlx5dv_devx_umem_reg.3.md
  mlx5dv_dr_flow.3.md
  mlx5dv_dump.3.md
  mlx5dv_flow_action_esp.3.md
  mlx5dv_get_clock_info.3
  mlx5dv_init_obj.3
  mlx5dv_is_supported.3.md
  mlx5dv_modify_qp_lag_port.3.md
  mlx5dv_modify_qp_sched_elem.3.md
  mlx5dv_modify_qp_udp_sport.3.md
  mlx5dv_open_device.3.md
  mlx5dv_pp_alloc.3.md
  mlx5dv_query_device.3
  mlx5dv_query_qp_lag_port.3.md
  mlx5dv_sched_node_create.3.md
  mlx5dv_ts_to_ns.3
  mlx5dv_wr_post.3.md
  mlx5dv.7
)
rdma_alias_man_pages(
 mlx5dv_alloc_var.3 mlx5dv_free_var.3
 mlx5dv_create_mkey.3 mlx5dv_destroy_mkey.3
 mlx5dv_devx_alloc_uar.3 mlx5dv_devx_free_uar.3
 mlx5dv_devx_create_cmd_comp.3 mlx5dv_devx_destroy_cmd_comp.3
 mlx5dv_devx_create_event_channel.3 mlx5dv_devx_destroy_event_channel.3
 mlx5dv_devx_create_cmd_comp.3 mlx5dv_devx_get_async_cmd_comp.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_general_cmd.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_obj_destroy.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_obj_query.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_obj_query_async.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_obj_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_qp_query.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_cq_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_cq_query.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_wq_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_wq_query.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_srq_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_srq_query.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_ind_tbl_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_ind_tbl_query.3
 mlx5dv_devx_subscribe_devx_event.3 mlx5dv_devx_subscribe_devx_event_fd.3
 mlx5dv_devx_umem_reg.3 mlx5dv_devx_umem_dereg.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_aso.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_table.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_ibv_qp.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_devx_tir.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_vport.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_array.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_flow_counter.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_drop.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_default_miss.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_flow_sampler.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_flow_meter.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_modify_header.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_packet_reformat.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_pop_vlan.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_push_vlan.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_tag.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_destroy.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_modify_aso.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_modify_flow_meter.3
 mlx5dv_dr_flow.3 mlx5dv_dr_domain_create.3
 mlx5dv_dr_flow.3 mlx5dv_dr_domain_destroy.3
 mlx5dv_dr_flow.3 mlx5dv_dr_domain_sync.3
 mlx5dv_dr_flow.3 mlx5dv_dr_domain_set_reclaim_device_memory.3
 mlx5dv_dr_flow.3 mlx5dv_dr_matcher_create.3
 mlx5dv_dr_flow.3 mlx5dv_dr_matcher_destroy.3
 mlx5dv_dr_flow.3 mlx5dv_dr_rule_create.3
 mlx5dv_dr_flow.3 mlx5dv_dr_rule_destroy.3
 mlx5dv_dr_flow.3 mlx5dv_dr_table_create.3
 mlx5dv_dr_flow.3 mlx5dv_dr_table_destroy.3
 mlx5dv_dump.3 mlx5dv_dump_dr_domain.3
 mlx5dv_dump.3 mlx5dv_dump_dr_matcher.3
 mlx5dv_dump.3 mlx5dv_dump_dr_rule.3
 mlx5dv_dump.3 mlx5dv_dump_dr_table.3
 mlx5dv_pp_alloc.3 mlx5dv_pp_free.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_leaf_create.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_leaf_destroy.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_leaf_modify.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_node_destroy.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_node_modify.3
 mlx5dv_wr_post.3 mlx5dv_wr_set_dc_addr.3
 mlx5dv_wr_post.3 mlx5dv_qp_ex_from_ibv_qp_ex.3
 mlx5dv_wr_post.3 mlx5dv_wr_mr_interleaved.3
 mlx5dv_wr_post.3 mlx5dv_wr_mr_list.3
)

=== pyverbs/providers/mlx5/CMakeLists.txt ===
# SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
# Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file

rdma_cython_module(pyverbs/providers/mlx5 mlx5
  mlx5dv.pyx
  mlx5_enums.pyx
  mlx5dv_sched.pyx
)

=== debian/changelog ===
rdma-core (33.2-1) unstable; urgency=medium

  * New upstream bug-fix release:
    - libhns: Fix wrong range of a mask
    - verbs: Fix attr_optional() when 'IOCTL_MODE=write' is used
    - mlx4: Fix mlx4_read_clock returned errno value
    - efa: Fix use of uninitialized query device response
    - libhns: Avoid accessing NULL pointer when locking/unlocking CQ
    - mlx5: Fix mlx5_read_clock returned errno value
    - bnxt_re/lib: Check AH handler validity before use
    - iwpmd: Check returned value of parse_iwpm_msg
    - libhns: Bugfix for calculation of extended sge

 -- Benjamin Drung <benjamin.drung@ionos.com>  Thu, 03 Jun 2021 11:19:24 +0200

rdma-core (33.1+git20210317-1) unstable; urgency=medium

  * New upstream bug-fix snapshot:
    - mlx5: Fix uuars to have the 'uar_mmap_offset' data
    - pyverbs: Fix Mlx5 QP constructor
    - efa: Fix DV extension clear check
    - verbs: Fix possible port loop overflow
    - ibacm: Fix possible port loop overflow
    - mlx5: DR, Check new cap for isolated VL TC QP
    - kernel-boot: Fix VF lookup
    - mlx5: DR, Force QP drain on table creation
    - libhns: Avoid double release of a pointer
    - libhns: Correct definition of DB_BYTE_4_TAG_M
    - libhns: Remove assert to check whether a pointer is NULL
    - libhns: Remove the unnecessary mask on QPN of CQE
    - libhns: Remove unnecessary mask of ownerbit
    - libhns: Remove unnecessary barrier when poll cq
    - rdma-ndd: fix udev racy issue for system with multiple InfiniBand HCAs
    - verbs: Fix create CQ comp_mask check
  * Update my email address

 -- Benjamin Drung <benjamin.drung@ionos.com>  Mon, 12 Apr 2021 11:28:57 +0200

=== debian/control ===
Source: rdma-core
Maintainer: Benjamin Drung <benjamin.drung@ionos.com>
Section: net
Priority: optional
Build-Depends: cmake (>= 2.8.11),
               cython3,
               debhelper-compat (= 13),
               dh-python,
               dpkg-dev (>= 1.17),
               libnl-3-dev,
               libnl-route-3-dev,
               libsystemd-dev,
               libudev-dev,
               ninja-build,
               pandoc,
               pkg-config,
               python3-dev,
               python3-docutils,
               valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x]
Rules-Requires-Root: no
Standards-Version: 4.5.1
Vcs-Git: https://github.com/linux-rdma/rdma-core.git -b debian/master
Vcs-Browser: https://github.com/linux-rdma/rdma-core
Homepage: https://github.com/linux-rdma/rdma-core

Package: rdma-core
Architecture: linux-any
Depends: lsb-base (>= 3.2-14~),
         udev,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: dmidecode, ethtool, iproute2
Breaks: infiniband-diags (<< 2.0.0)
Replaces: infiniband-diags (<< 2.0.0)
Description: RDMA core userspace infrastructure and documentation
 This package provides the basic boot time support for systems that use the
 Linux kernel's remote direct memory access (RDMA) subystem which includes
 InfiniBand, iWARP, and RDMA over Converged Ethernet (RoCE).
 .
 Several kernel RDMA support daemons are included:
  - The rdma-ndd daemon which watches for RDMA device changes and/or hostname
    changes and updates the Node Description of the RDMA devices based on
    those changes.
  - The iWARP Port Mapper Daemon (iwpmd) which provides a kernel support
    service in userspace for iWARP drivers to claim TCP ports through the
    standard socket interface.

Package: ibacm
Architecture: linux-any
Depends: lsb-base (>= 3.2-14~),
         rdma-core (>= 15),
         ${misc:Depends},
         ${shlibs:Depends}
Description: InfiniBand Communication Manager Assistant (ACM)
 The IB ACM implements and provides a framework for name, address, and
 route (path) resolution services over InfiniBand.
 It is intended to address connection setup scalability issues running
 MPI applications on large clusters.  The IB ACM provides information
 needed to establish a connection, but does not implement the CM protocol.
 A primary user of the ibacm service is the librdmacm library.

Package: ibverbs-providers
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: libefa1, libipathverbs1, libmlx4-1, libmlx5-1, libmthca1
Replaces: libipathverbs1 (<< 15),
          libmlx4-1 (<< 15),
          libmlx5-1 (<< 15),
          libmthca1 (<< 15)
Breaks: libipathverbs1 (<< 15),
        libmlx4-1 (<< 15),
        libmlx5-1 (<< 15),
        libmthca1 (<< 15)
Description: User space provider drivers for libibverbs
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 An RDMA driver consists of a kernel portion and a user space portion.
 This package contains the user space verbs drivers:
 .
  - bnxt_re: Broadcom NetXtreme-E RoCE HCAs
  - cxgb4: Chelsio T4 iWARP HCAs
  - efa: Amazon Elastic Fabric Adapter
  - hfi1verbs: Intel Omni-Path HFI
  - hns: HiSilicon Hip06 SoC
  - i40iw: Intel Ethernet Connection X722 RDMA
  - ipathverbs: QLogic InfiniPath HCAs
  - mlx4: Mellanox ConnectX-3 InfiniBand HCAs
  - mlx5: Mellanox Connect-IB/X-4+ InfiniBand HCAs
  - mthca: Mellanox InfiniBand HCAs
  - ocrdma: Emulex OneConnect RDMA/RoCE device
  - qedr: QLogic QL4xxx RoCE HCAs
  - rxe: A software implementation of the RoCE protocol
  - siw: A software implementation of the iWarp protocol
  - vmw_pvrdma: VMware paravirtual RDMA device

Package: ibverbs-utils
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Examples for the libibverbs library
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 This package contains useful libibverbs1 example programs such as
 ibv_devinfo, which displays information about InfiniBand devices.

Package: libibverbs-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: ibverbs-providers (= ${binary:Version}),
         libibverbs1 (= ${binary:Version}),
         libnl-3-dev,
         libnl-route-3-dev,
         ${misc:Depends}
Description: Development files for the libibverbs library
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 This package is needed to compile programs against libibverbs1.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: libibverbs1
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Recommends: ibverbs-providers
Breaks: ibverbs-providers (<< 33~)
Description: Library for direct userspace use of RDMA (InfiniBand/iWARP)
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 For this library to be useful, a device-specific plug-in module
 should also be installed.
 .
 This package contains the shared library.

Package: libibumad-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libibumad3 (= ${binary:Version}), ${misc:Depends}
Description: Development files for libibumad
 libibumad provides userspace Infiniband Management Datagram (uMAD)
 functions which sit on top of the uMAD modules in the kernel.
 These are used by InfiniBand diagnostic and management tools.
 .
 This package is needed to compile programs against libibumad.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: libibumad3
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: InfiniBand Userspace Management Datagram (uMAD) library
 libibumad provides userspace Infiniband Management Datagram (uMAD)
 functions which sit on top of the uMAD modules in the kernel.
 These are used by InfiniBand diagnostic and management tools.
 .
 This package contains the shared library.

Package: librdmacm-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libibverbs-dev, librdmacm1 (= ${binary:Version}), ${misc:Depends}
Description: Development files for the librdmacm library
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package is needed to compile programs against librdmacm1.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: librdmacm1
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library for managing RDMA connections
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package contains the shared library.

Package: rdmacm-utils
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Examples for the librdmacm library
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package contains useful librdmacm1 example programs such as
 rping and udaddy.

Package: srptools
Architecture: linux-any
Depends: lsb-base (>= 3.2-14~),
         rdma-core (>= 15),
         udev,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Tools for Infiniband attached storage (SRP)
 In conjunction with the kernel ib_srp driver, srptools allows you to
 discover and use Infiniband attached storage devices which use the
 SCSI RDMA Protocol (SRP).

Package: python3-pyverbs
Section: python
Architecture: linux-any
Depends: rdma-core (>= 21),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Python bindings for rdma-core
 Pyverbs provides a Python API over rdma-core, the Linux userspace C API for
 the remote direct memory access (RDMA) stack.
 .
 One goal is to provide easier access to RDMA: RDMA has a steep learning curve
 as is and the C interface requires the user to initialize multiple structs
 before having usable objects. Pyverbs attempts to remove much of this overhead
 and provide a smoother user experience.

Package: infiniband-diags
Architecture: linux-any
Depends: libibnetdisc5 (= ${binary:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

COHERENT_DMA_ARCHS = amd64 arm64 i386 ia64 powerpc powerpcspe ppc64 ppc64el s390x sparc64 x32

dh_params = --with python3 --builddirectory=build-deb

%:
	dh $@ $(dh_params)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build-deb
	for package in ibverbs-providers libibverbs-dev rdma-core; do \
		test ! -e debian/$$package.install.backup || mv debian/$$package.install.backup debian/$$package.install; \
	done

# Upstream wishes to use CMAKE_BUILD_TYPE=Release, and ensures that has a
# sensible basis of options (eg no -O3, including -g). Debian specific options
# come from CFLAGS as usual.
#
# Upstream encourages the use of Ninja to build the source, convince dh to use
# it until someone writes native support for dh+cmake+ninja.
DH_AUTO_CONFIGURE := "--" \
	             "-GNinja" \
		     "-DDISTRO_FLAVOUR=Debian" \
		     "-DCMAKE_BUILD_TYPE=Release" \
		     "-DCMAKE_INSTALL_SYSCONFDIR:PATH=/etc" \
		     "-DCMAKE_INSTALL_SYSTEMD_SERVICEDIR:PATH=/lib/systemd/system" \
		     "-DCMAKE_INSTALL_INITDDIR:PATH=/etc/init.d" \
		     "-DCMAKE_INSTALL_LIBEXECDIR:PATH=/usr/lib" \
		     "-DCMAKE_INSTALL_SHAREDSTATEDIR:PATH=/var/lib" \
		     "-DCMAKE_INSTALL_RUNDIR:PATH=/run" \
		     "-DCMAKE_INSTALL_UDEV_RULESDIR:PATH=/lib/udev/rules.d" \
		     "-DCMAKE_INSTALL_PERLDIR:PATH=/usr/share/perl5" \
		     "-DENABLE_STATIC=1" \
		     $(EXTRA_CMAKE_FLAGS)

override_dh_auto_configure:
	if [ -e /usr/bin/python3 ]; then \
		dh_auto_configure $(DH_AUTO_CONFIGURE) \
				-DPYTHON_EXECUTABLE:PATH=/usr/bin/python3 \
				-DCMAKE_INSTALL_PYTHON_ARCH_LIB:PATH=/usr/lib/python3/dist-packages; \
	else \
		dh_auto_configure $(DH_AUTO_CONFIGURE) \
			        -DNO_PYVERBS=1; \
	fi


override_dh_auto_build:
	ninja -C build-deb -v

# upstream does not ship test cases
override_dh_auto_test:

override_dh_auto_install:
# Some providers are disabled on architectures that are not able to do coherent DMA
ifneq (,$(filter-out $(COHERENT_DMA_ARCHS),$(DEB_HOST_ARCH)))
	for package in ibverbs-providers libibverbs-dev rdma-core; do \
		test -e debian/$$package.install.backup || cp debian/$$package.install debian/$$package.install.backup; \
	done
	sed -i '/efa\|mlx[45]/d' debian/ibverbs-providers.install debian/libibverbs-dev.install debian/rdma-core.install
endif
	DESTDIR=$(CURDIR)/debian/tmp ninja -C build-deb install

# The following files are not used on Debian (we ship our own sysvinit script)
INST_EXCLUDE := "etc/init.d/srpd" \
		"etc/init.d/ibacm" \
		"usr/sbin/run_srp_daemon" \
		"usr/sbin/srp_daemon.sh"
INST_EXCLUDE := $(addprefix -X,$(INST_EXCLUDE))
override_dh_install:
	if [ -e build-deb/python/pyverbs/__init__.py ]; then \
		dh_install $(INST_EXCLUDE); \
	else \
		dh_install -Npython3-pyverbs $(INST_EXCLUDE) --remaining-packages; \
	fi

override_dh_missing:
	dh_missing --fail-missing $(INST_EXCLUDE)

# cmake installs the correct init scripts in the correct place, just setup the
# pre-postrms
override_dh_installinit:
	dh_installinit -prdma-core --onlyscripts --name=iwpmd
	dh_installinit --remaining-packages

override_dh_installsystemd:
	dh_installsystemd -pibacm --no-start ibacm.service
	dh_installsystemd -pibacm ibacm.socket
	dh_installsystemd --remaining-packages

# Provider plugin libaries are not shared libraries and do not belong in the
# shlibs file.
# librspreload is a LD_PRELOAD library and does not belong in the shlib files
SHLIBS_EXCLUDE = "/libibverbs/" "librspreload" "/ibacm/"
SHLIBS_EXCLUDE := $(addprefix --exclude=,$(SHLIBS_EXCLUDE))
override_dh_makeshlibs:
	dh_makeshlibs $(SHLIBS_EXCLUDE)

# Upstream encourages the use of 'build' as the developer build output
# directory, allow that directory to be present and still allow dh to work.
.PHONY: build
build:
	dh $@ $(dh_params)

## rdma-core 36.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -53,7 +53,12 @@
 #      (without man pages) when neither pandoc/rst2man nor the pandoc-prebuilt
 #      directory are available.
 
-cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
+if (${CMAKE_VERSION} VERSION_LESS "3.18.1")
+	# Centos 6 support
+	cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
+else()
+	cmake_minimum_required(VERSION 3.18.1 FATAL_ERROR)
+endif()
 project(rdma-core C)
 
 # CMake likes to use -rdynamic too much, they fixed it in 3.4.
@@ -72,11 +77,11 @@
 set(PACKAGE_NAME "RDMA")
 
 # See Documentation/versioning.md
-set(PACKAGE_VERSION "33.2")
+set(PACKAGE_VERSION "36.0")
 # When this is changed the values in these files need changing too:
 #   debian/control
 #   debian/libibverbs1.symbols
-set(IBVERBS_PABI_VERSION "33")
+set(IBVERBS_PABI_VERSION "34")
 set(IBVERBS_PROVIDER_SUFFIX "-rdmav${IBVERBS_PABI_VERSION}.so")
 
 #-------------------------
@@ -221,7 +226,7 @@
 # but turn off some that are not terribly useful for this source.
 # FIXME: I wonder how many of the signed compares are bugs?
 RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WARNINGS
-  "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter")
+  "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wno-stringop-overread")
 RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WMISSING_PROTOTYPES "-Wmissing-prototypes")
 RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WMISSING_DECLARATIONS "-Wmissing-declarations")
 RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WWRITE_STRINGS "-Wwrite-strings")
@@ -307,7 +312,3 @@
  #include <sys/stat.h>
  #include <sys/socket.h>
  #include <fcntl.h>
- int main(int argc,const char *argv[]) {
-    open(\".\",O_RDONLY | O_CLOEXEC);
-    socket(AF_INET, SOCK_STREAM | SOCK_CLOEXEC, 0);
-    return 0;

=== pyverbs/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,16 @@
 # SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
 # Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file
+# Copyright (c) 2020, Intel Corporation. All rights reserved. See COPYING file
+
+publish_internal_headers(""
+  dmabuf_alloc.h
+)
+
+if (DRM_INCLUDE_DIRS)
+  set(DMABUF_ALLOC dmabuf_alloc.c)
+else()
+  set(DMABUF_ALLOC dmabuf_alloc_stub.c)
+endif()
 
 rdma_cython_module(pyverbs ""
   addr.pyx
@@ -8,15 +19,20 @@
   cmid.pyx
   cq.pyx
   device.pyx
+  dmabuf.pyx
+  ${DMABUF_ALLOC}
   enums.pyx
+  flow.pyx
+  fork.pyx
   mem_alloc.pyx
   mr.pyx
   pd.pyx
   qp.pyx
+  spec.pyx
+  srq.pyx
   wr.pyx
   xrcd.pyx
-  srq.pyx
-  )
+)
 
 rdma_python_module(pyverbs
   __init__.py

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -16,11 +16,21 @@
   test_device.py
   test_efa_srd.py
   test_efadv.py
+  test_flow.py
+  test_fork.py
   test_mlx5_cq.py
   test_mlx5_dc.py
+  test_mlx5_dm_ops.py
+  test_mlx5_dr.py
+  test_mlx5_flow.py
   test_mlx5_lag_affinity.py
+  test_mlx5_mkey.py
   test_mlx5_pp.py
+  test_mlx5_query_port.py
+  test_mlx5_raw_wqe.py
+  test_mlx5_rdmacm.py
   test_mlx5_sched.py
+  test_mlx5_timestamp.py
   test_mlx5_uar.py
   test_mlx5_udp_sport.py
   test_mlx5_var.py

=== providers/hns/CMakeLists.txt ===
rdma_provider(hns
  hns_roce_u.c
  hns_roce_u_buf.c
  hns_roce_u_db.c
  hns_roce_u_hw_v1.c
  hns_roce_u_hw_v2.c
  hns_roce_u_verbs.c
)

=== providers/mlx5/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 endif()
 
 rdma_shared_provider(mlx5 libmlx5.map
-  1 1.17.${PACKAGE_VERSION}
+  1 1.20.${PACKAGE_VERSION}
   buf.c
   cq.c
   dbrec.c

=== providers/mlx5/man/CMakeLists.txt ===
--- 
+++ 
@@ -17,22 +17,30 @@
   mlx5dv_devx_query_eqn.3.md
   mlx5dv_devx_subscribe_devx_event.3.md
   mlx5dv_devx_umem_reg.3.md
+  mlx5dv_dm_map_op_addr.3.md
   mlx5dv_dr_flow.3.md
   mlx5dv_dump.3.md
   mlx5dv_flow_action_esp.3.md
   mlx5dv_get_clock_info.3
   mlx5dv_init_obj.3
   mlx5dv_is_supported.3.md
+  mlx5dv_map_ah_to_qp.3.md
+  mlx5dv_mkey_check.3.md
   mlx5dv_modify_qp_lag_port.3.md
   mlx5dv_modify_qp_sched_elem.3.md
   mlx5dv_modify_qp_udp_sport.3.md
   mlx5dv_open_device.3.md
   mlx5dv_pp_alloc.3.md
+  mlx5dv_qp_cancel_posted_send_wrs.3.md
   mlx5dv_query_device.3
+  mlx5dv_query_port.3.md
   mlx5dv_query_qp_lag_port.3.md
+  mlx5dv_reserved_qpn_alloc.3.md
   mlx5dv_sched_node_create.3.md
   mlx5dv_ts_to_ns.3
+  mlx5dv_wr_mkey_configure.3.md
   mlx5dv_wr_post.3.md
+  mlx5dv_wr_set_mkey_sig_block.3.md
   mlx5dv.7
 )
 rdma_alias_man_pages(
@@ -58,6 +66,7 @@
  mlx5dv_devx_qp_modify.3 mlx5dv_devx_ind_tbl_query.3
  mlx5dv_devx_subscribe_devx_event.3 mlx5dv_devx_subscribe_devx_event_fd.3
  mlx5dv_devx_umem_reg.3 mlx5dv_devx_umem_dereg.3
+ mlx5dv_devx_umem_reg.3 mlx5dv_devx_umem_reg_ex.3
  mlx5dv_dr_flow.3 mlx5dv_dr_action_create_aso.3
  mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_table.3
  mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_ibv_qp.3
@@ -77,6 +86,7 @@
  mlx5dv_dr_flow.3 mlx5dv_dr_action_destroy.3
  mlx5dv_dr_flow.3 mlx5dv_dr_action_modify_aso.3
  mlx5dv_dr_flow.3 mlx5dv_dr_action_modify_flow_meter.3
+ mlx5dv_dr_flow.3 mlx5dv_dr_domain_allow_duplicate_rules.3
  mlx5dv_dr_flow.3 mlx5dv_dr_domain_create.3
  mlx5dv_dr_flow.3 mlx5dv_dr_domain_destroy.3
  mlx5dv_dr_flow.3 mlx5dv_dr_domain_sync.3
@@ -92,13 +102,18 @@
  mlx5dv_dump.3 mlx5dv_dump_dr_rule.3
  mlx5dv_dump.3 mlx5dv_dump_dr_table.3
  mlx5dv_pp_alloc.3 mlx5dv_pp_free.3
+ mlx5dv_reserved_qpn_alloc.3 mlx5dv_reserved_qpn_dealloc.3
  mlx5dv_sched_node_create.3 mlx5dv_sched_leaf_create.3
  mlx5dv_sched_node_create.3 mlx5dv_sched_leaf_destroy.3
  mlx5dv_sched_node_create.3 mlx5dv_sched_leaf_modify.3
  mlx5dv_sched_node_create.3 mlx5dv_sched_node_destroy.3
  mlx5dv_sched_node_create.3 mlx5dv_sched_node_modify.3
+ mlx5dv_wr_mkey_configure.3 mlx5dv_wr_set_mkey_access_flags.3
+ mlx5dv_wr_mkey_configure.3 mlx5dv_wr_set_mkey_layout_interleaved.3
+ mlx5dv_wr_mkey_configure.3 mlx5dv_wr_set_mkey_layout_list.3
  mlx5dv_wr_post.3 mlx5dv_wr_set_dc_addr.3
  mlx5dv_wr_post.3 mlx5dv_qp_ex_from_ibv_qp_ex.3
  mlx5dv_wr_post.3 mlx5dv_wr_mr_interleaved.3
  mlx5dv_wr_post.3 mlx5dv_wr_mr_list.3
+ mlx5dv_wr_post.3 mlx5dv_wr_raw_wqe.3
 )

=== pyverbs/providers/mlx5/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,14 @@
 # Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file
 
 rdma_cython_module(pyverbs/providers/mlx5 mlx5
+  dr_action.pyx
+  dr_domain.pyx
+  dr_matcher.pyx
+  dr_rule.pyx
+  dr_table.pyx
   mlx5dv.pyx
   mlx5_enums.pyx
+  mlx5dv_flow.pyx
+  mlx5dv_mkey.pyx
   mlx5dv_sched.pyx
 )
